; $Id: dcs_reduction_stratagems.pro,v 1.4 2002/07/13 20:30:59 john Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
pro dcs_reduction_stratagems,filename=filename,strategy,button_tags,modifiable,n_stratagems,$
	n_skipped_stratagems
;************************************************************************************************
; This procedure reads lines of information from a file, one per stratagem. Each line includes the
; name of the stratagem, a phrase that describes the stratagem, and a flag which describes
; whether or not the stratagem is checked and whether or not it can be modified by the user.
;
compile_opt strictarr
;
; Open the file.
openr,unit,filename,/get_lun
;
; Read the total number of strategems and the number of stratagems skipped if working with
; summed files.
readf,unit,n_stratagems,n_skipped_stratagems
sname=strarr(n_stratagems)
button_tags=strarr(n_stratagems)
modifiable=intarr(n_stratagems)
chars=""
;
; Read information for each stratagem.
for i=0,n_stratagems-1 do begin
	readf,unit,chars
	a=strsplit(chars," {2,}",/extract,/regex)
	if (n_elements(a) ne 4) then stop,"Error reading the file ",filename
	sname[i]=a[0]; this array is used to construct the structure "strategy".
	button_tags[i]=a[1]; this array is returned.
	modifiable[i]=fix(a[2]); this array is returned.
endfor
;
; Close the file.
free_lun,unit
;
; Construct a command that creates the structure named "strategy".
com="strategy={"
for i=0,n_stratagems-1 do begin
	com=com+sname[i]+":0"
	if (i lt n_stratagems-1) then com=com+"," else com=com+"}"
endfor
;
; Execute the command.
result=execute(com)
;
end