; $Id: dcs_read_multiple_messages.pro,v 1.4 2002/07/13 20:14:57 john Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
pro dcs_read_multiple_messages,inputfile,message_str
;************************************************************************************************
;
compile_opt strictarr
;
; This routine reads multiple multiline message texts from a single input file called
; inputfile (!). Each text is preceded by a title. Each text is formed into a single string.
; Titles and texts are stored in the string arrays message_title and message_text
; respectively.
;
on_ioerror, no_file
get_lun,unit
openr,unit,inputfile
;
; Initialization of variables.
imsg=-1
line=""
message_title=strarr(1000)
message_text=strarr(1000)
message_choices=strarr(1000)
message_def=intarr(1000)
message_can=intarr(1000)
;
; Start reading file.
while not eof(unit) do begin
	readf,unit,line
	case line of
		"TITLE": begin; read the next line which is a message title
			imsg=imsg+1
			readf,unit,line
			message_title[imsg]=line
		end
		"MESSAGE": ; do nothing
		"CHOICES": begin
			readf,unit,line
			message_choices[imsg]=line
		end
		"DEF": begin
			readf,unit,line
			message_def[imsg]=line
		end
		"CAN": begin
			readf,unit,line
			message_can[imsg]=line
		end
		"END": begin; calculate number of messages and create an output structure.
			nmsg=imsg+1
			message_str={title:message_title[0:nmsg-1],$
				text:message_text[0:nmsg-1],$
				choices:message_choices[0:nmsg-1],$
				def:message_def[0:nmsg-1],$
				can:message_can[0:nmsg-1]}
			return
		end
		else: begin ; the line is all or part of a message text
			if (strlen(message_text[imsg]) eq 0) then $
				message_text[imsg]=line else $
				message_text[imsg]=message_text[imsg]+" "+line
			end
	endcase
endwhile
;
read_err: free_lun,unit
return
;
no_file: begin
	free_lun,unit
	if (!debug) then print,"There is no file named ",inputfile
	stop,"Program terminated."
end
;
end