; $Id: centerwindow.pro,v 1.2 2002/01/14 20:59:25 amunter Exp $
; centerwindow.pro
; Written by R.M.Dimeo (11/11/01)
;
; NAME:
;       CENTERWINDOW
;
; PURPOSE:
;       This procedure creates a window of the desired
;		size centered in the screen
;
; CATEGORY:
;       Graphics.
;
; CALLING SEQUENCE:
;       CENTERWINDOW,WIN = WIN, XSIZE = XSIZE, YSIZE = YSIZE
;
; INPUTS:
;
;	NONE
;
; KEYWORDS:
;       WIN:			window index (default = free)
;
;       XSIZE:		   horizontal window size (default = 350)
;
;		YSIZE:		   vertical window size (default = 300)
;
; EXAMPLES:
;
; 					winxsize = 450 & winysize = 400
; 					centerwindow,win = 0,xsize = winxsize,ysize = winysize
; 					plot,findgen(10),findgen(10)
;
; PROCEDURE:
;
; MODIFICATION HISTORY:
;
;-
pro centerwindow,win = win,xsize = xsize,ysize = ysize
if n_elements(xsize) eq 0 then xsize = 350
if n_elements(ysize) eq 0 then ysize = 300
device,get_screen_size = ss
sx = ss[0] & sy = ss[1]
xpos = fix(0.5*(sx-xsize))
ypos = fix(0.5*(sy-ysize))
if n_elements(win) eq 0 then begin
  window,/free,xsize = xsize,ysize = ysize,xpos = xpos,ypos = ypos
endif else begin
  window,win,xsize = xsize,ysize = ysize,xpos = xpos,ypos = ypos
endelse
return
end