;$Id: dave_valid.pro,v 1.2 2002/09/27 18:30:08 jmspark Exp $
function dave_valid, davePtr, full=full

message, 'pass 0', /continue

	if n_elements( davePtr ) ne 1 then return, 0
	if not ptr_valid( davePtr ) then return, 0
	if size( *davePtr, /tname ) ne 'STRUCT' then return, 0

message, 'pass 1', /continue

	print, tag_names( *davePtr )
	help, tag_names( *davePtr )
	if ( where( tag_names( *davePtr ) eq 'DATASTRPTR' ))[0] eq -1 then return, 0

message, 'pass 1.1', /continue

	if not ptr_valid( (*davePtr).dataStrPtr ) then return, 0

message, 'pass 1.2', /continue

	dataStrPtr = (*davePtr).dataStrPtr

message, 'pass 1.3', /continue

	if size( *dataStrPtr, /tname ) ne 'STRUCT' then return, 0

	message, 'pass 2', /continue

	if ( where( tag_names( *dataStrPtr ) eq 'COMMONSTR' ))[0]  eq -1 then return, 0
	if size( (*dataStrPtr).commonStr, /tname ) ne 'STRUCT' then return, 0

	message, 'pass 3', /continue

	if ( where( tag_names( (*dataStrPtr).commonStr ) eq 'HISTPTR' ))[0] eq -1 then return, 0

	message, 'pass 3.1', /continue

	if not ptr_valid( (*dataStrPtr).commonStr.histPtr ) then return, 0

	message, 'pass 3.2', /continue

	histPtr = (*dataStrPtr).commonStr.histPtr

	message, 'pass 3.3', /continue

	; More tests follow if the 'full' keyword is set.
	if not keyword_set( full ) then return, 1

	if size( *histPtr, /tname ) ne 'STRUCT' then return, 0

	message, 'pass 4', /continue

	if ( where( tag_names( *histPtr ) eq 'QTY' ))[0] eq -1 then return, 0
	if ( where( tag_names( *histPtr ) eq 'ERR' ))[0] eq -1 then return, 0
	if ( where( tag_names( *histPtr ) eq 'X' ))[0] eq -1 then return, 0
	if ( where( tag_names( *histPtr ) eq 'Y' ))[0] eq -1 then return, 0

	message, 'pass 5', /continue

	if n_elements( (*histPtr).qty ) eq 0 then return, 0
	if n_elements( (*histPtr).err ) eq 0 then return, 0
	if n_elements( (*histPtr).x ) eq 0 then return, 0
	if n_elements( (*histPtr).y ) eq 0 then return, 0

	message, 'pass 6', /continue

	return, 1

end