;$Id: pointer_recursive_cleanup.pro,v 1.1 2002/05/01 13:50:57 jmspark Exp $
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
; Pointer_recursive_cleanup frees pointers recursively.
; By Sungil Park. Feb. 25, 2002.
;*******************************************************************************
pro Pointer_recursive_cleanup, Ptr

	case n_elements( Ptr ) of
		0: return
		1: ptr = ptr[0]
		else: begin
			for i = 0, n_elements( Ptr ) - 1 do begin
				Pointer_recursive_cleanup, Ptr[i]
			endfor
			return
		end
	endcase

	if ( ptr_valid( Ptr ) )[0] then begin

		case size( *Ptr, /tname ) of

			'STRUCT': begin
				for j = 0, n_tags( *Ptr ) - 1 do begin
					Pointer_recursive_cleanup, (*Ptr).(j)
				endfor
			end
			'POINTER': begin
				Pointer_recursive_cleanup, *Ptr
			end
			'OBJREF': begin
				obj_destroy, *Ptr
			end

			else: begin
				; print, size( *Ptr, /tname )
			end

		endcase

		ptr_free, Ptr

	endif

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************