;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; NAME:
;  VARTYPE:
; PURPOSE
;  Deterimines the type name of an IDL variable. 
;  Should work with intrinsic types (integer, float, etc) and
;  user-defined types such as structure and class names.
; SYNTAX:
;  type = vartype(variable)
; INPUTS:
;   variable (in): The variable whose type is required
;   
; OUTPUT:
;   returns the IDL type which should be one of:
;   INT, BYTE, FLOAT, DOUBLE, STRING, LONG etc, struct name, class
;   name. Or an empty string if name is unknown or if an anonymous struct.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; RTA
; 

function vartype, variable

type = size(variable,/tname)
if (type eq "OBJREF") then type = obj_class(variable)
if (type eq "STRUCT") then type = tag_names(variable,/structure_name)

return, type

end
